module FeedBo
  class Cookie < Element
  
    def draw
      s = Level::FIELD_SIZE
      @svg.image width: s, height: s, :'xlink:href' => h.image_path("cookie.svg")
    end
  
    def hit
      return false if @visible == false
      
      @level.points += 1
      @visible = false
      
      @svg.animateTransform attributeName: "transform", type: "scale", from: "1", to: "0", 
        begin: @level.step*Level::STEP_DUR, dur: 0.05, additive: 'sum', fill: 'freeze'
      @svg.animateMotion by: "#{Level::FIELD_SIZE/2},#{Level::FIELD_SIZE/2}", begin: @level.step*Level::STEP_DUR, dur: 0.05, fill: 'freeze'
    end
  
  end
end